module AdriverApi
  module ApiMethods
   
    # List of all user ad companies
    # Список всех рекламных кампаний данного аккаунта
    def ads(raw: false)
      response = make_request('ads', user_id: @user_id.to_s)
      return response if raw
    end


    # List of all delegated to user ad companies
    # Список всех рекламных кампаний делегированных данному аккаунту
    def ads_delegated(raw: false)
      response = make_request('ads/delegated', user_id: @user_id.to_s)
      return response if raw
      Array.wrap(response.body['feed']['entry']).map{|x| x['id'].split('/').last}
    end

    # Info about ad
    def ad(ad_id, raw: false)
      response = make_request("ads/#{ad_id}")
      return response if raw
      h = {}
      h[:id] = response.body['entry']['content']['ad']['id']
      h[:name] = response.body['entry']['content']['ad']['name']
      h[:enable] = response.body['entry']['content']['ad']['enable']
      h[:adplacements] = Array.wrap(response.body['entry']['content']['ad']['adPlacements']['href']).map{|x| x.split('/').last}
      h
    end

    # Сценарии
    #TODO: возвращать так же сценарий "дефолтовые баннеры"
    def adplacements(ad_id, raw: false)
      response = make_request('adplacements', ad_id: ad_id)
      return response if raw 
      Array.wrap(response.body['feed']['entry']).map{|x| {id: x['content']['adPlacement']['id'], name: x['content']['adPlacement']['name'], banners: x['content']['adPlacement']['banners'] ? Array.wrap(x['content']['adPlacement']['banners']['href']).map{|x2| x2.split('/').last} : []} }
    end

    def banner(ban_id, raw: false)
      response = make_request("banners/#{ban_id}")
      return response if raw
      h = {}
      h[:url] = response.body['entry']['content']['banner']['target_url']
      h
    end

    def stat_banner(ban_id, period: :daily, start_date: nil, stop_date: Date.today, raw: false)
      start_date ||= (Date.today - 365)
      response = make_request("stat/banners/#{ban_id}", start_date: start_date, stop_date: stop_date, granularity: period)
      return response if raw
      h = {}
      Array.wrap(response.body['entry']['content']['statObject']['stat']['item']).each{|x| h[x['date']] = {views: x['exp'], clicks: x['click']} }
      h
    end

  end
end

# Brand.all_parents.each{|x| t=x.presets.new; t.name='default'; t.is_default=true; t.ys_competitors = x.competitors.pluck(:id).join(','); t.wts_competitors = t.ys_competitors; t.save}