module AdriverApi

  class Error < StandardError; end

  # Raised when Adriver returns the HTTP status code 400
  class BadRequest < Error; end

  # Raised when Adriver returns the HTTP status code 404
  class NotFound < Error; end

  # Raised when Adriver returns the HTTP status code 401
  class UnAuthorized < Error; end

  # Raised when Adriver returns the HTTP status code 401 and response.body says: 'Not authorized to work with object'
  class AccessDenied < Error; end

  # Raised when Adriver returns the HTTP status code 500
  class InternalServerError < Error; end

end