require 'faraday'

module FaradayMiddleware
  class RaiseHttpException < Faraday::Middleware
    def call(env)
      @app.call(env).on_complete do |response|
        case response[:status].to_i
        when 400
          raise AdriverApi::BadRequest
        when 401
          raise AdriverApi::AccessDenied if response.body.include? 'Not authorized to work with object'
          raise AdriverApi::UnAuthorized
        when 404
          raise AdriverApi::NotFound
        end
      end
    end

    def initialize(app)
      super app
      @parser = nil
    end
  end
end